/*
	OOP C++ Beispiel fr eine aus einer DLL exportierte Klasse mit Factory-Funktion.

	Header Datei
*/

#define DLLFUNC __declspec(dllexport)

// Dies verwenden wenn der Header von einem Programm aus beuntzt wird das die DLL benutzt
// #define DLLFUNC __declspec(dllimport)

class Test {
	public:
		// Gewhnliche C++ Funktionen, DLL-exportiert
		DLLFUNC Test (int x, double y);
		DLLFUNC void calculate (double z);
		DLLFUNC int getX ();
		DLLFUNC double getY ();
		
		// Factory Funktion
		DLLFUNC static Test* makeInstance (int x, double y);
		// Lschen-Funktion
		DLLFUNC static void deleteInstance (Test* t);
	protected:
		int m_x;
		double m_y;
};